module Geo.Make

( make
)

where

-- $Log: Make.hs,v $
-- Revision 1.7  2002/09/02 15:41:00  mrahn
-- shorter imports
--
-- Revision 1.6  2002/09/02 10:25:23  georg
-- adjacents list in WayGraph
--
-- Revision 1.5  2002/09/01 16:27:11  michael
-- homebases added
--
-- Revision 1.4  2002/09/01 16:01:34  michael
-- homeposition managment
--
-- Revision 1.3  2002/09/01 11:25:36  joe
-- kante
--
-- Revision 1.2  2002/09/01 11:12:55  michael
-- Int for each Node added
--
-- Revision 1.1  2002/09/01 10:15:37  joe
-- make
--

import World.Type
import List (sort)
import Geo.Type
import Geo.Util (reverse_edge)
import Util.RestrictedFiniteMap
import Util.RestrictedSet

{-# SPECIALIZE make ::  [Position] -> [ (Edge Int, Way) ] -> WayGraph Int #-}

make :: Ord a 
      => [Position] -> [ (Edge a, Way) ] -> WayGraph a
make hbases ews =
    let -- collect information on edges
	fm = addListToFM_C union emptyFM
	   $ do (e, w) <- ews
		return (e, unitSet w)
	-- collect all edges
	es = mkSet $ keysFM fm
	-- collect all nodes
	ns = mkSet $ do 
	     e <- keysFM fm	
	     [ from e, to e ]
	hp = addListToFM emptyFM 
	   $ do (h, p) <- zip (sort $ setToList ns) hbases 
		return (h, p)
	ad1 = addListToFM_C union emptyFM
	   $ do (e, _) <- ews
		return (from e, unitSet e)
	ad2 = addListToFM_C union ad1
	   $ do (e, _) <- ews
		return (to e, unitSet $ reverse_edge e)
    in	WayGraph { nodes = ns
		 , edges = es
		 , ewfm  = fm
		 , homepos = hp
		 , adjacent = ad2
		 }
