module Geo.Util where
    
--import Monad (guard)
import Geo.Type
import Geo.Distance
import qualified World.Type as W
--import qualified World.Query.GetFieldSize as WGFS


-- $Log: Util.hs,v $
-- Revision 1.16  2002/09/02 15:39:32  mrahn
-- shorter imports
--
-- Revision 1.15  2002/09/02 11:30:04  joe
-- Segmentation durch explizites rumlaufen
--
-- Revision 1.14  2002/09/02 10:38:02  georg
-- get_wgraph_edges_from delivers edges from one node
--
-- Revision 1.13  2002/09/02 10:25:23  georg
-- adjacents list in WayGraph
--

-- add an edge
addEdge :: Ord a => WayGraph a -> Edge a -> WayGraph a 
addEdge g e = g { edges = addToSet (edges g) e }

-- add a node
-- addNode :: Ord a => WayGraph a -> a -> WayGraph a 
-- addNode g n = g { nodes = addToSet (nodes g) n }


-- add a way to an edge
addWay :: Ord a => FiniteMap (Edge a) [Way] -> Edge a -> Way -> FiniteMap (Edge a) [Way]
addWay dmap edge way = addToFM dmap edge ways 
    where ways = case lookupFM dmap edge of
		 Just elt -> (way:elt)
		 Nothing  -> [way]

					 
{- not used I think (Georg)
merge :: Ord a => WayGraph a -> WayGraph a -> WayGraph a
merge g1 g2 = WayGraph { nodes = union (nodes g1) (nodes g2)
		       , edges = union (edges g1) (edges g2)
		       , ewfm  = plusFM (ewfm g1) (ewfm g2)
		       , homepos = homepos g1 
		       }
-}

get_membership :: W.Info -> DistanceMap -> W.Position -> IO(Membership)
get_membership info dmap (x,y) = let (width, _) = W.field_size info
				     in do
					ms <- readArray dmap
					 $ get_index x y width
					return ms

-- DistanceMap address calculation
-- x 1 to width
-- y 1 to ..
-- width
-- retrun index from 1 ..
get_index :: Int -> Int -> Int -> Int
get_index x y width = x + (y-1)* (width +1)


printDistanceMap :: W.Info -> DistanceMap -> IO()
printDistanceMap info d = do
	let (width, height) = W.field_size info
	let fields = range ((1,1),(width,height))
	mapM (\ (x,y) -> do 
					m<- readArray d (get_index x y width)
					print m 
		 ) fields
	return ()

-- returns the ways of an edge
shortest_way :: Ord a => WayGraph a-> Edge a -> Way
shortest_way graph edge = case (lookupFM fm edge) of
			  Nothing   -> Way { len=0, pos=(1,1)}
			  Just ways -> (setToList ways)!!0
    where fm = ewfm graph

get_homebase :: Ord a => WayGraph a -> a -> W.Position
get_homebase graph node = lookupWithDefaultFM (homepos graph) (-1,-1) node


max_distance :: W.Info -> Int
max_distance info = let (w,h) = W.field_size info
		    in w*h
			
reverse_edge :: Edge a -> Edge a
reverse_edge e = Edge {from = to e, to= from e}

get_wgraph_edges_from :: (Ord a) => WayGraph a -> a -> [Edge a]
get_wgraph_edges_from wgraph point = setToList 
	$ lookupWithDefaultFM (adjacent wgraph) emptySet point 

