module Util.Debug 

( debug 
, hput, hget

) where

-- $Log: Debug.hs,v $
-- Revision 1.4  2002/09/01 13:00:48  joe
-- printer
--
-- Revision 1.3  2002/08/31 11:31:57  joe
-- debug
--
-- Revision 1.2  2002/08/31 10:43:31  joe
-- init
--
-- Revision 1.1  2002/08/31 10:39:55  joe
-- init
--

import IO
import Monad ( when )
import Exception ( block )

debug_flag :: Bool
debug_flag = True

debug :: String -> IO ()
debug msg = when debug_flag $ block $ do
    hPutStrLn stderr msg
    hFlush stderr

hput :: Handle -> String -> IO ()
hput h msg = do
    debug $ ">> " ++ msg
    hPutStrLn h msg
    hFlush h -- ??

hget :: Handle -> IO String
hget h = do
    msg <- hGetLine h
    hFlush h -- ??
    debug $ "<< " ++ msg
    return msg
