module World

( create                      -- Handle -> IO ( Map , Info )
, update                      -- Info -> String -> Info
, pack_update                 -- Info -> String -> Info
, money_update                -- Info -> Int -> Info
, Map                         -- Array Int Word8
, RobotID                     -- Int
, PackID                      -- Int
, Position                    -- ( Int , Int )
, Pos			      -- Int
, Package ( weight            -- Maybe Int
          , destination       -- Maybe Position
          , pos               -- Either Position RobotID 
          , was_dropped       -- Bool 
          )
, Info ( my_id                -- RobotID
       , my_capacity          -- Int
       , my_money             -- Int
       , my_score             -- Int
       , field_size           -- Position
       , packages             -- FiniteMap PackID   Package
       , robot_packs          -- FiniteMap RobotID [ PackID ]
       , robot_poss           -- FiniteMap RobotID  Position
       , our_actions          -- [ Action ]
       , hb_contents          -- FiniteMap Position Bool3
       )
, Field (..)                  -- Water | Open | Wall | Base
, module World.Query
)

where

import World.Type
import World.Create
import World.Update
import World.Pack_Update
import World.Money_Update
import World.Query
