module World.Create where

import World.Type
import Data.Array.MArray
import Data.Array.IO
import Util.RestrictedFiniteMap
import IO

------------------------------------------------------------------------------

create                        :: Handle -> IO ( Map , Info )
create handle                 =  do

     first_line <- hGetLine handle

     let ws        = words first_line
         ( w , h ) = ( read $ ws !! 0 , read $ ws !! 1 ) :: ( Int , Int )

     arr <- newArray_ ( 1 , (w+1) * h )

     hGetArray handle arr $ (w+1) * h

     info_line <- hGetLine handle

     let ws2                 = words info_line
	 info                = Info
			       { my_id          = read $ ws2 !! 0
			       , my_capacity    = read $ ws2 !! 1
			       , my_money       = read $ ws2 !! 2
			       , my_score       = 0
			       , field_size     = ( w , h )
			       , packages       = emptyFM
			       , robot_packs    = emptyFM
			       , robot_poss     = emptyFM
			       , our_actions    = []
			       , hb_contents    = emptyFM
			       }

-- NO
--     farr <- unsafeFreeze arr

     return ( arr , info )
