module World.Pack_Update 

( pack_update                 -- Info -> [ String ] -> Info
)

where

import World.Type
import World.Query
import Util.RestrictedFiniteMap

------------------------------------------------------------------------------

pack_update                   :: ( Map , Info ) -> String -> IO Info
pack_update (m,i) []          =  do

    let the_pos = robot_pos ( my_id i ) i

    f <- get_field (m,i) the_pos

    case f == Base of

     True -> return 
	     $ i { hb_contents = addToFM ( hb_contents i ) the_pos False3 }
     _ -> return i

pack_update (m,i) s            =  do

    let the_pos = robot_pos ( my_id i ) i
        new_i   = pack_update' ( robot_pos ( my_id i ) i )
                                 i
                               ( words s )

    f <- get_field (m,i) the_pos

    case f == Base of

     True -> return
	     $ new_i { hb_contents = addToFM ( hb_contents i ) the_pos True3 }
     _ -> return new_i

------------------------------------------------------------------------------

pack_update'                  :: Position -> Info -> [ String ] -> Info
pack_update' _ i []           =  i
pack_update' my_pos i (spid:sxpos:sypos:sweight:ss)
                              =  pack_update' my_pos
                                 ( i { packages = addToFM ( packages i ) 
                                                          new_pid
                                                          newpack
				     }
				 )
                                 ss
    where new_pid             =  read spid
          xpos                =  read sxpos
          ypos                =  read sypos
          new_weight          =  read sweight

          newpack             =  Package
              { weight        =  Just new_weight
	      , destination   =  Just ( xpos , ypos )
	      , pos           =  Left my_pos
	      , was_dropped   =  False
	      }

pack_update' _ _ _            =  error "incorrect package description"
