module World.Query.Get_Field where

import World.Type
import World.Query.GetFieldSize
import Data.Array.MArray
import Util.Debug

------------------------------------------------------------------------------

get_field                     :: ( Map , Info ) -> Position -> IO Field
get_field (m,i) (x,y)         =  do

    f <- readArray m ( ( w + 1 ) * ( y - 1 ) + x )

    return $ case f of
                          35  -> Wall
                          46  -> Open
                          64  -> Base
                          126 -> Water
                          _   -> error "get_field: STRANGE things happend"

    where (w,h)               =  get_field_size i


get_field_with_width :: Map -> Int -> Position -> IO Field
get_field_with_width m w (x, y) = do
    f <- readArray m ( ( w + 1 ) * ( y - 1 ) + x )

    return $ case f of
                          35  -> Wall
                          46  -> Open
                          64  -> Base
                          126 -> Water
                          _   -> error "get_field: STRANGE things happend"
   
