module World.Query.Possible_Command

where

import World.Type
import World.Query.GetNeighbors
import World.Query.Robo_Pos
import World.Move
import Util.Command
import Util.RestrictedFiniteMap
import Util.RestrictedSet
import Monad

------------------------------------------------------------------------------

possible_commands             :: ( Map , Info ) -> IO [ Command ]
possible_commands (m,i)       =  do

    ds <- filterM ( valid_pos (m,i) . flip move my_pos ) [ N , S , E , W ]

    return $                     ( do d <- ds
				      return $ Command 1 ( Move d ) 
				 )
                                 ++
                                 [ Command 1 ( Pick the_packs_to_pick )
                                 , Command 1 ( Drop my_packs          )
				 ]
                  
    where my_pos              =  robot_pos ( my_id i ) i
          my_packs            =  case lookupFM ( robot_packs i ) ( my_id i ) of
				  Nothing -> []
				  Just ps -> take 1 $ setToList ps
          the_packs_to_pick   =  keysFM 
				 $ filterFM ( \ _ p -> pos p == Left my_pos )
				 $ packages i
